module SmsSpeedwayApi
  require 'net/http'
  class RESPONSE
    attr_writer :message, :code

    def message
        @message||""
    end

    def code
        @code||-1 
    end

    def success?
	code == 0
    end

  end

  class SMS
    attr_accessor :company, :username, :password
    attr_writer  :testmode, :numbers, :message
   
    def testmode
	@testmode||false
    end

    def speedwayUrl
	testmode ? "http://dev.sms-speedway.com/queue_sms.php?TESTMODE=1&" : "http://www.sms-speedway.com/queue_sms.php?"
    end

    def message
        @message||""
    end

    def numbers
        @numbers||[]
    end

    def validate_message
      ret=RESPONSE.new
      if message.length == 0
	ret.code, ret.message=1,"Message is empty"
	return ret
      end

      ret.code=0
      ret
    end

    def validate_numbers
      ret=RESPONSE.new
      if numbers.length == 0
        ret.code, ret.message=2,"No numbers to send to"
        return ret
      end

      ret.code=0
      ret
    end

    def validate_login
      ret=RESPONSE.new
      if @company == nil || @company.length == 0 
        ret.code, ret.message=3,"Company ID is missing"
	return ret
      end

      if @username == nil || @username.length == 0 
        ret.code, ret.message=4,"User ID is missing"
	return ret
      end

      if @password == nil || @password.length == 0 
        ret.code, ret.message=5,"Password is missing"
	return ret
      end

      ret.code, ret.message=0,""
      ret
    end

    def numbers_as_string
      return (@numbers||[]).join(",")

    end

   def getURL
     return "#{speedwayUrl}message=#{URI::encode(message)}&company=#{@company}&login=#{@username}&password=#{@password}&numbers=#{URI::encode(numbers_as_string)}"
   end
 
    def send
      ret=validate_message
      return ret if ! ret.success?

      ret=validate_numbers
      return ret if ! ret.success?

      ret=validate_login
      return ret if ! ret.success?

      uri = URI(getURL)
      req = Net::HTTP.get(uri)

      if  req.include?("Transmission successfully queued")
         ret.code,ret.message=0,"Transmission successfully queued"
      else
        ["*** LOGIN FAILURE ***"].each_with_index { |msg,idx|
         ret.code,ret.message=100+idx,msg if req.include?(msg)
        }
      end

      ret
    end
  end
end
